use Test;
BEGIN { plan tests => 11 }
use Data::Config;
Data::Config->options(-quiet => 1);
$a = new Data::Config;

# there must be no param
ok( $a->param == 0 );

# these params are not defined
ok( not defined $a->param('') );
ok( not defined $a->param('Adam') );

# affecting a param (Tk-style), then checking it's there
$a->param(-shito_3 => 'Sachiel');
ok( $a->param('shito_3') eq 'Sachiel');

# affecting a param (hashref), then checking it's there
$a->param({shito_5 => 'Ramiel'});
ok( $a->param('shito_5') eq 'Ramiel');

# there must be two params
ok( $a->param == 2 );

# affecting three params (Tk-style), then checking they're there
$a->param(-shito_4 => 'Samsiel', -shito_6 => 'Gagiel', -shito_8 => 'Sandalfon');
ok( @p = $a->param(qw(shito_4 shito_6 shito_8)) 
    and $p[0] eq 'Samsiel' 
    and $p[1] eq 'Gagiel' 
    and $p[2] eq 'Sandalfon' );

# affecting three params (hashref), then checking they're there
$a->param({shito_7 => 'Israfel', shito_9 => 'Matarael', shito_10 => 'Saraqiel'});
ok( @p = $a->param(qw(shito_7 shito_9 shito_10)) 
    and $p[0] eq 'Israfel' 
    and $p[1] eq 'Matarael' 
    and $p[2] eq 'Saraqiel' );

# affecting some params (Tk-style) while reading the value of others
@p = $a->param(shito_7, -shito_11 => 'Iroel', shito_5, -shito_12 => 'Leliel');
ok( $p[0] eq 'Israfel' and $p[1] eq 'Ramiel');

# affecting some params (hashref) while reading the value of others
@p = $a->param(shito_9, {shito_13 => 'Bardiel'}, shito_3, {shito_14 => 'Zeruel'});
ok( $p[0] eq 'Matarael' and $p[1] eq 'Sachiel' 
    and $a->param('shito_13') eq 'Bardiel' 
    and $a->param('shito_14') eq 'Zeruel');

# affectiong some params (both styles) while reading the value of others
@p = $a->param(shito_14, -shito_15 => 'Arael', shito_10, 
     {shito_16 => 'Armisael', shito_17 => 'Tabris'}, shito_6);
ok( $p[0] eq 'Zeruel' and $p[1] eq 'Saraqiel' and $p[2] eq 'Gagiel'
    and $a->param('shito_15') eq 'Arael' 
    and $a->param('shito_16') eq 'Armisael' 
    and $a->param('shito_17') eq 'Tabris');
