use Test;
BEGIN { plan tests => 8 }
use Data::Config;
Data::Config->options(-quiet => 1);
$a = new Data::Config;

# read the data from a file
$a->read_source('t/children.txt');
# check the internal filename
ok( $a->{'state'}{'filename'} eq 't/children.txt' );
# check the number of actual parameters
ok( scalar $a->param == 5 );

# check the data is as expected
ok( @children = $a->param(qw(
        First_Children Second_Children Third_Children 
        Fourth_Children Fifth_Children
    ))
  and  $children[0] eq "Ayanami Rei"
  and  $children[1] eq "Ikari Shinji"
  and  $children[2] eq "Soryu Asuka Langley"
  and  $children[3] eq "Suzuhara Toji"
  and  $children[4] eq "Nagisa Kaoru"
  );


# read additionnal data from another file
$a->read_source('t/eva.txt');
# the internal filename must be the last given to read_source()
ok( $a->{'state'}{'filename'} eq 't/eva.txt' );
ok( scalar $a->param == 11 );
ok( @data = $a->param(qw(
        First_Children Second_Children Third_Children 
        Fourth_Children Fifth_Children
        Eva_00 Eva_01 Eva_02 Eva_03 Eva_04 Eva_05
    ))
       # check the children are still here
  and  $data[0] eq "Ayanami Rei"
  and  $data[1] eq "Ikari Shinji"
  and  $data[2] eq "Soryu Asuka Langley"
  and  $data[3] eq "Suzuhara Toji"
  and  $data[4] eq "Nagisa Kaoru"
       # now check the Evas are also here
  and  $data[5] eq "Prototype Unit"
  and  $data[6] eq "Test Unit"
  and  $data[7] eq "First Unit of Production Serie 1"
  and  $data[8] eq "Second Unit of Production Serie 1"
  and  $data[9] eq "Third Unit of Production Serie 1"
  and  $data[10]eq "First Unit of Production Serie 2"
  );

undef $a;
$a = new Data::Config;

# read the data from a filehandle
$a->read_source(\*DATA);
ok( scalar $a->param == 5 );

# check the data is as expected
ok( @children = $a->param(qw(
        First_Children Second_Children Third_Children 
        Fourth_Children Fifth_Children
    ))
  and  $children[0] eq "Ayanami Rei"
  and  $children[1] eq "Ikari Shinji"
  and  $children[2] eq "Soryu Asuka Langley"
  and  $children[3] eq "Suzuhara Toji"
  and  $children[4] eq "Nagisa Kaoru"
  );


__END__
First_Children = Ayanami Rei
Second_Children = Ikari Shinji
Third_Children = Soryu Asuka Langley
Fourth_Children = Suzuhara Toji
Fifth_Children = Nagisa Kaoru
