use Test;
BEGIN { 
  # In order to make this test, we need Data::Dumper, 
  # but it is not required by Data::Config, therefore 
  # it the module is not available, the test is skipped. 
  eval {
    require Data::Dumper;
    require IO::File;
  };
  $do_test = $@ ? 0 : 1;
  plan tests => 1;
}
use Data::Config;
Data::Config->options(-quiet => 1);

if($do_test) {
    $a = new Data::Config;
    $a->read_source('t/eva.txt');
    
    # dump $a in a temp file
    $fh = IO::File->new_tmpfile() or die "Unable to make new temporary file: $!";
    print $fh $a->dump_param;
    seek($fh, 0, 0);  # rewind
    
    # create $b reading the temp file; $b should be a clone of $a
    $b = new Data::Config;
    $b->read_source($fh);
    
    # check the clones are real twins
    ok( Data::Dumper::Dumper($a->{param}) , Data::Dumper::Dumper($b->{param}) );

} else {
    print "# Data::Dumper and/or IO::File are not available\n";
    ok(1);
}
