use Test;
BEGIN {
  # In order to make this test, we need Data::Dumper,
  # but it is not required by Data::Config, therefore
  # it the module is not available, the test is skipped.
  eval {
    require Data::Dumper;
    require POSIX;
  };
  $do_test = $@ ? 0 : 1;
  plan tests => 2;
}
use Data::Config;

if($do_test) {
    $a = new Data::Config;
    $a->read_source('t/eva.txt');
    
    $a->param({
      Eva_03 => $a->param('Eva_03')." - Became the 13th Angel when possessed by Bardiel", 
      Eva_04 => $a->param('Eva_04')." - Destroyed in the explosion of the Nerv base in the USA", 
    });
    
    # write $a in a temp file
    my $file_a = POSIX::tmpnam();
    $a->write_source($file_a);
    
    # read that file in another object
    $b = new Data::Config $file_a;
    
    # check that both are identical
    ok( Data::Dumper::Dumper($a->{param}), Data::Dumper::Dumper($b->{param}) );
    
    # write $b in a temp file
    my $file_b = POSIX::tmpnam();
    $b->write_source($file_b);
    
    # read that file in $a
    undef $a;
    $a = new Data::Config $file_b;
    
    # check that both are identical
    ok( Data::Dumper::Dumper($a->{param}), Data::Dumper::Dumper($b->{param}) );

    # remove temp files
    unlink $file_a, $file_b;

} else {
    print "# Data::Dumper and/or POSIX are not available\n";
    ok(1);
    ok(1);
}
